/*
			  Manual Page File IO

	Opens Manual Page files and datas to plain text XML and
	saves plain text XML to Manual Page files and datas.
 */

#ifndef MANPAGE_FIO_H
#define MANPAGE_FIO_H


typedef struct _MPHeader		MPHeader;
#define MP_HEADER(p)			((MPHeader *)(p))

typedef struct _MPSection		MPSection;
#define MP_SECTION(p)			((MPSection *)(p))


/*
 *	Header:
 */
struct _MPHeader {

	char		*name,
			*section_number,	/* Not a section within a
						 * ManPage */
			*version,
			*author,
			*catagory;

	char		**comments_lines_list;
	int		ncomments_lines;

};


/*
 *	Section:
 */
struct _MPSection {

	char		*name;			/* Section Name */

	char		**lines_list;		/* Plain text XML lines */
	int		nlines;

};


/* HPHeader */
extern MPHeader *MPHeaderNew(void);
extern void MPHeaderDelete(MPHeader *head);

/* MPSection */
extern MPSection *MPSectionNew(void);
extern void MPSectionDelete(MPSection *sect);
extern void MPSectionsListClear(
	MPSection **sections_list, const int nsections
);

/* Open */
extern int MPFileOpen(
	const char *path,
	MPHeader **mp_header_rtn,
	MPSection ***mp_section_rtn, int *mp_total_sections_rtn,
	int (*progress_cb)(unsigned long, unsigned long, void *),
	void *progress_data
);
extern int MPDataOpen(
	const char *data,
	MPHeader **mp_header_rtn,
	MPSection ***mp_section_rtn, int *mp_total_sections_rtn,
	int (*progress_cb)(unsigned long, unsigned long, void *),
	void *progress_data
);

/* Save */
extern int MPFileSave(
	const char *path,
	MPHeader *mp_header,
	MPSection **mp_section, int mp_total_sections,
	int (*progress_cb)(unsigned long, unsigned long, void *),
	void *progress_data
);
extern int MPDataSave(
	char **data_rtn,
	MPHeader *mp_header,
	MPSection **mp_section, int mp_total_sections,
	int (*progress_cb)(unsigned long, unsigned long, void *),
	void *progress_data
);


#endif	/* MANPAGE_FIO_H */
