#ifndef MENUBUTTON_H
#define MENUBUTTON_H

#include <gtk/gtk.h>


/*
 *	Menu map trigger type codes:
 */
typedef enum {
	MENU_BUTTON_MAP_TYPE_PRESSED,		/* Map on press */
	MENU_BUTTON_MAP_TYPE_PRESSED_DRAG	/* Map on press and short drag */
} menu_button_map_trigger;


extern GtkWidget *MenuButtonNewH(
	const gchar *label,
	guchar **icon_data,
	GtkWidget **menu_rtn
);
extern GtkWidget *MenuButtonNewV(
	const gchar *label,
	guchar **icon_data,
	GtkWidget **menu_rtn
);
extern GtkWidget *MenuButtonNewPixmap(
	guchar **icon_data,
	GtkWidget **menu_rtn
);

extern GtkWidget *MenuButtonGetMenu(GtkWidget *w);
extern void MenuButtonSetMenu(
	GtkWidget *w,
	GtkMenu *menu
);

extern void MenuButtonSetMapTrigger(
	GtkWidget *w,
	const menu_button_map_trigger map_trigger
);

#endif	/* MENUBUTTON_H */
