#ifndef VIEWER_CB_H
#define VIEWER_CB_H

#include <gtk/gtk.h>
#include "tool_bar.h"
#include "viewer.h"


extern gint ViewerDeleteEventCB(GtkWidget *widget, GdkEvent *event, gpointer data);
extern void ViewerCloseCB(GtkWidget *widget, gpointer data);
extern void ViewerExitCB(GtkWidget *widget, gpointer data);
extern gint ViewerKeyEventCB(
        GtkWidget *widget, GdkEventKey *key, gpointer data
);

extern void ViewerSwitchPageCB(
	GtkNotebook *notebook, GtkNotebookPage *page, guint page_num,
	gpointer data
);
extern void ViewerPageToggleCB(GtkWidget *widget, gpointer data);

extern gint ViewerViewKeyEventCB(
	GtkWidget *widget, GdkEventKey *key, gpointer data
);
extern gint ViewerViewButtonEventCB(
	GtkWidget *widget, GdkEventButton *button, gpointer data
);

extern void ViewerIndexBranchExpandCB(GtkWidget *widget, gpointer data);

extern void ViewerToolBarItemActivateCB(
	ToolBarItem *item, gint id, gpointer data
);

extern void ViewerOpenCB(GtkWidget *widget, gpointer data);
extern void ViewerClearCB(GtkWidget *widget, gpointer data);
extern void ViewerStopCB(GtkWidget *widget, gpointer data);
extern void ViewerIndexGotoParentCB(GtkWidget *widget, gpointer data);
extern void ViewerIndexViewCB(GtkWidget *widget, gpointer data);
extern void ViewerIndexRefreshCB(GtkWidget *widget, gpointer data);
extern void ViewerCopyCB(GtkWidget *widget, gpointer data);
extern void ViewerSelectAllCB(GtkWidget *widget, gpointer data);
extern void ViewerUnselectAllCB(GtkWidget *widget, gpointer data);
extern void ViewerOptionsCB(GtkWidget *widget, gpointer data);

extern gint ViewerMenuMapCB(GtkWidget *widget, GdkEvent *event, gpointer data);

extern void ViewerManPageActivateCB(GtkWidget *widget, void *data);
extern void ViewerFindActivateCB(GtkWidget *widget, void *data);

extern void ViewerFindInPagesActivateCB(GtkWidget *widget, void *data);

extern void ViewerIndexCTreeSelectCB(
	GtkCTree *ctree, GtkCTreeNode *branch, gint column, gpointer data
); 
extern void ViewerIndexCTreeUnselectCB(
	GtkCTree *ctree, GtkCTreeNode *branch, gint column, gpointer data
);
extern void ViewerIndexCTreeExpandCB(
	GtkCTree *ctree, GtkCTreeNode *node, gpointer data
);

extern void ViewerReconfiguredCB(viewer_struct *v);


#endif	/* VIEWER_CB_H */
